import { h } from 'preact';
import { route } from 'preact-router';
import { useContext,useState } from 'preact/hooks';
import AppState from '../../store/AppState';
import Breadcrumbs from '../../components/breadcrumbs';

function Login() {
    let [sessiondata, setsession]= useContext(AppState).session;
    const [val, set] = useState({ username: '', password: '', error: null });
    const navigation = ["Login"];
    if(sessiondata.active)
        route('/', true);
    function onSubmit(e) {
        e.preventDefault();
        //sucess
        if (val.username === 'admin') {
            let newsession = {
                type: 'start',
                username: 'affe',
                token: 'dsf4w3qr'
            }
            setsession(newsession);
        }
        else {
            set({ ...val, error: "user" });
        }
        set({ username: '', password: '' });
    }
    return (
        <div class="container">
            <Breadcrumbs items={navigation} />

            <form id="login_form" onSubmit={onSubmit} >
                <p >
                    Bitte melden Sie sich mit ihren Nutzerdaten an.

                </p>
                {val.error !== null && <span style={'color: red'}>Fehler: Ungültige Anmeldedaten.</span>}
                <div class="input-box">
                    <input id="name" type="text" placeholder="Username" onInput={e => set({ ...val, username: e.target.value })} value={val.username} />
                    <label for="name">Benutzername</label>
                </div>
                <div class="input-box">
                    <input id="pass" type="password" placeholder="Passwort" onInput={e => set({ ...val, password: e.target.value })} value={val.password} />
                    <label for="pass">Password</label>
                </div>
                <input type="submit" value="Submit" />

            </form>
        </div>
    );

}

export default Login;